using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System.Diagnostics;

namespace Tutorial_5_1
{
    class Rectangle2D
    {
        private float m_center_x;
        private float m_center_y;
        private float m_width;
        private float m_height;

        public Rectangle2D()
        {
            m_center_x = 0;
            m_center_y = 0;
            m_width = 0;
            m_height = 0;
        }

        public void SetCenter(float x, float y)
        {
            m_center_x = x;
            m_center_y = y;
        }

        public void SetSize(float width, float height)
        {
            m_width = width;
            m_height = height;
        }

        public void Draw(GraphicsDevice device)
        {
            Debug.Assert(device != null, "device not valid on Rectangle2D draw call");

            if (m_width > 0 || m_height > 0)
            {
                DeviceVertexFormat[] v = new DeviceVertexFormat[4];

                for (int i = 0; i < 4; i++)
                {
                    v[i] = new DeviceVertexFormat();
                    v[i].Color = new Color(new Vector4(.4f, .4f, .4f, 1));
                }

                v[0].Position = new Vector3(m_center_x - m_width / 2.0f, m_center_y + m_height / 2.0f, 0);
                v[1].Position = new Vector3(m_center_x - m_width / 2.0f, m_center_y - m_height / 2.0f, 0);
                v[2].Position = new Vector3(m_center_x + m_width / 2.0f, m_center_y - m_height / 2.0f, 0);
                v[3].Position = new Vector3(m_center_x + m_width / 2.0f, m_center_y + m_height / 2.0f, 0);

                device.DrawUserPrimitives(PrimitiveType.TriangleFan, v, 0, 2);
            }
        }
    }
}
