using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using UWBGL_WinForms_Lib1;
using UWBGL_XNA_Lib10;

namespace XNA_WCSupport
{
    public partial class XNA_WCSupport : Form
    {
        private DrawOnlyHandler mView;
		private UWB_BoundingBox worldBound;
        private Timer mTimer;

        public XNA_WCSupport()
        {
            mView = new DrawOnlyHandler();
            mTimer = new Timer();            
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
			mView.Initialize(PlaceHolder_Graphics);

			worldBound = new UWB_BoundingBox(new Vector3(10, 20, 0), new Vector3(20, 30, 0));
			mView.setWCWindow(ref worldBound);
           
            UWBGL_XNA_Lib10.UWB_Utility.mEchoTextBox = echoTextBox;

            //set our timer's interval in milliseconds and set the mTimer_Tick function to be
            //called every time it reaches that interval
            mTimer.Interval = 25;
            mTimer.Tick += new EventHandler(mTimer_Tick);
            mTimer.Start();

			float width = 0;
			float height = 0;

			Program.getModel().getWorldBounds(ref width, ref height);


            UWBGL_XNA_Lib10.UWB_Utility.echoToStatusArea("Form Load Complete");
        }

        private void Button_Quit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void mTimer_Tick(object sender, EventArgs e)
        {
            Program.getModel().updateSimulation();

            mView.DrawGraphics();
        }

		private void checkBoxShowPivot_CheckedChanged(object sender, EventArgs e)
		{
			Program.getModel().showPivot(checkBoxShowPivot.Checked);
		}
    }
}
