using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using UWBGL_WinForms_Lib1;
using UWBGL_XNA_Lib11;

namespace XNA_SceneNode
{
    public partial class XNA_SceneNode : Form
    {
        private DrawOnlyHandler mView;
		private UWB_BoundingBox worldBound;
        private Timer mTimer;

        public XNA_SceneNode()
        {
            mView = new DrawOnlyHandler();
            mTimer = new Timer();            
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
			mView.Initialize(PlaceHolder_Graphics);

			UWB_BoundingBox worldBounds = Program.getModel().getWorldBounds();
			mView.setWCWindow(ref worldBounds);
           
            UWBGL_XNA_Lib11.UWB_Utility.mEchoTextBox = echoTextBox;

            //set our timer's interval in milliseconds and set the mTimer_Tick function to be
            //called every time it reaches that interval
            mTimer.Interval = 25;
            mTimer.Tick += new EventHandler(mTimer_Tick);
            mTimer.Start();

			float width = 0;
			float height = 0;

			Program.getModel().getWorldBounds(ref width, ref height);


            UWBGL_XNA_Lib11.UWB_Utility.echoToStatusArea("Form Load Complete");
        }

        private void Button_Quit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void mTimer_Tick(object sender, EventArgs e)
        {
            Program.getModel().updateSimulation();

            mView.DrawGraphics();
        }

		private void radioButton1_CheckedChanged(object sender, EventArgs e)
		{
			if (radioButton1.Checked)
			{
				Program.getModel().activateParentTransform();
				xFormInfoControl1.onModelActivateXFormChange();
			}
		}

		private void radioButton2_CheckedChanged(object sender, EventArgs e)
		{
			if (radioButton2.Checked)
			{
				Program.getModel().activateChildTransform();
				xFormInfoControl1.onModelActivateXFormChange();
			}
		}
    }
}
