using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using UWBGL_WinForms_Lib1;


namespace XNA_ModelView
{
    public partial class XNA_ModelView : Form
    {
        CircleRadiusControls mCircleControls;
        DrawOnlyHandler mView;
        Timer mTimer;

        public XNA_ModelView()
        {
            mCircleControls = new CircleRadiusControls();
            mView = new DrawOnlyHandler();
            mTimer = new Timer();
            
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            mView.Initialize(PlaceHolder_Graphics);
            Utility.UWBGL_ReplaceFormControl(mCircleControls, PlaceHolderControl);
            
            //set our timer's interval in milliseconds and set the mTimer_Tick function to be
            //called every time it reaches that interval
            mTimer.Interval = 25;
            mTimer.Tick += new EventHandler(mTimer_Tick);
            mTimer.Start();
        }

        private void Button_Quit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void mTimer_Tick(object sender, EventArgs e)
        {
            if (mCircleControls.bSliderControl.Checked)
                Program.getModel().SetCircleRadius(mCircleControls.echoSliderControl.GetSliderValue());

            mView.DrawGraphics();
        }
    }
}