using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace UWBGL_XNA_Lib4
{
    public class UWB_PointGeom
    {
        protected Vector3 mPoint;
        protected Color mColor;
        protected float mPointSize;

        public UWB_PointGeom()
        {
            mPoint = Vector3.Zero;
            mPointSize = 2f;
        }

        public void setLocation(float x, float y, float z)
        {
            mPoint = new Vector3(x, y, z);
        }

        public Vector3 getLocation()
        {
            return mPoint;
        }

        public void setColor(Color color)
        {
            mColor = color;
        }

        public Color getColor()
        {
            return mColor;
        }

        public void setPointSize(float size)
        {
            mPointSize = size;
        }

        public float getPointSize()
        {
            return mPointSize;
        }

        public void draw(UWB_DrawHelper drawHelper)
        {
			if (drawHelper != null)
			{
				drawHelper.resetAttributes();
				drawHelper.setColor1(mColor);
				drawHelper.setPointSize(mPointSize);
				drawHelper.drawPoint(mPoint);
			}
        }
    }
}
