using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using UWBGL_WinForms_Lib1;
using UWBGL_XNA_Lib9;

namespace XNA_XFormInfo
{
    public partial class XNA_XFormInfo : Form
    {
        private DrawOnlyHandler mView;
		private UWB_BoundingBox worldBound;
        private Timer mTimer;

        public XNA_XFormInfo()
        {
            mView = new DrawOnlyHandler();
            mTimer = new Timer();            
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
			Program.getModel().setWorldAspectRatio(PlaceHolder_Graphics.Width, PlaceHolder_Graphics.Height);
            mView.Initialize(PlaceHolder_Graphics);

			worldBound = Program.getModel().getWorldBounds();
			mView.setWCWindow(ref worldBound);
           
            UWBGL_XNA_Lib9.UWB_Utility.mEchoTextBox = echoTextBox;

            //set our timer's interval in milliseconds and set the mTimer_Tick function to be
            //called every time it reaches that interval
            mTimer.Interval = 25;
            mTimer.Tick += new EventHandler(mTimer_Tick);
            mTimer.Start();

			float width = 0;
			float height = 0;

			Program.getModel().getWorldBounds(ref width, ref height);

			sliderTranslateY.OrientationToVertical(PlaceHolder_Graphics.Height - 20);
			sliderTranslateY.ChangeRangeValues(0f, height - 1f, 4f);

			sliderScaleY.OrientationToVertical(PlaceHolder_Graphics.Height - 20);
			sliderScaleY.ChangeRangeValues(0f, 5f, 1f);

			sliderTranslateX.ChangeRangeValues(0f, width - 1f, 1f);

			sliderScaleX.ChangeRangeValues(0f, 5f, 1f);

			sliderRotation.ChangeRangeValues(-90f, 90f, 0f);

			Program.getModel().setTranslation(1f, 4f);
			Program.getModel().setScale(1f, 1f);
			Program.getModel().setRotation(0f);

            UWBGL_XNA_Lib9.UWB_Utility.echoToStatusArea("Form Load Complete");
        }

        private void Button_Quit_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void mTimer_Tick(object sender, EventArgs e)
        {
            Program.getModel().updateSimulation();

            mView.DrawGraphics();
        }

		private void sliderControlY_Scroll(object sender, EventArgs e)
		{
			Program.getModel().setTranslation(sliderTranslateX.GetSliderValue(), sliderTranslateY.GetSliderValue());
		}

		private void sliderControlX_Scroll(object sender, EventArgs e)
		{
			Program.getModel().setTranslation(sliderTranslateX.GetSliderValue(), sliderTranslateY.GetSliderValue());
		}

		private void sliderScaleY_Scroll(object sender, EventArgs e)
		{
			Program.getModel().setScale(sliderScaleX.GetSliderValue(), sliderScaleY.GetSliderValue());
		}

		private void sliderScaleX_Scroll(object sender, EventArgs e)
		{
			Program.getModel().setScale(sliderScaleX.GetSliderValue(), sliderScaleY.GetSliderValue());
		}

		private void sliderRotation_Scroll(object sender, EventArgs e)
		{
			Program.getModel().setRotation(MathHelper.ToRadians(sliderRotation.GetSliderValue()));
		}
    }
}
